/*******************************************************************
*                                                                  *
*  Author      : Dr. Thomas Brandes, GMD, SCAI.LAB                 *
*  Copyright   : GMD St. Augustin, Germany                         *
*  Date        : Feb 94                                            *
*  Last Update : Feb 94                                            *
*                                                                  *
*  This Module is part of the DALIB                                *
*                                                                  *
*  INITIALIZATION OF PROGRAM for SP-1 or SP 2 (POE)                *
*                                                                  *
*  MODULE : init.c                                                 *
*                                                                  *
*  Function: Realization of System Dependent Operations            *
*                                                                  *
*******************************************************************/

#include <stdio.h>
#include <string.h>
#include "dalib.h"

#undef DEBUG

int tids[MAXP1];   /* communication with task identifiers */

void dalib_machine_enroll (NP)

int *NP;

{ int rank, size;
  int rc;
  int i;

  rc = mpc_environ (&size, &rank);
  
  pcb.i = rank+1;
  *NP   = size;

  for (i=1; i<=size; i++) tids[i] = i-1;

  if (pcb.i == 1)

      { /* only first process gets the parameters */

        eval_arg (*NP, *NP);

      }

   /* mailbox initialization is necessary */

   machine_mpi_init ();

} /* dalib_machine_enroll */

/*******************************************************************
*                                                                  *
*  dalib_machine_exit                                              *
*                                                                  *
*******************************************************************/

void dalib_machine_exit () 

{
  exit (0);

} /* dalib_machine_exit */

