# include "DerivedTypes.h"
# ifdef __cplusplus
extern "C" {
# include "General.h"
# include "rSystem.h"
}
# else
# include "General.h"
# include "rSystem.h"
# endif
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef rfalse
# define rfalse 0
# endif
# ifndef rtrue
# define rtrue 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = (free -= yyAlignedSize (sizeof (type))) >= start ? \
   (tree) free : alloc (sizeof (type)); \
  init (ptr, kind);
# else
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = make (kind);
# endif

/* line 20 "DerivedTypes.puma" */


# include <stdio.h>
# include "Idents.h"
# include "StringM.h"
 
# include "protocol.h"

# include "Types.h"

# define MODULE "DerivedTypes"
 
# undef DEBUG



# ifndef yyWrite
# define yyWrite(s) (void) fputs (s, yyf)
# endif
# ifndef yyWriteNl
# define yyWriteNl (void) fputc ('\n', yyf)
# endif

# include "yyDerivedTypes.h"

static void yyExit ARGS ((void)) { rExit (1); }

void (* DerivedTypes_Exit) ARGS ((void)) = yyExit;

# ifdef UNIX
static FILE * yyf = stdout;
# else
static FILE * yyf;
# endif
static rbool yyb;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module DerivedTypes, routine %s failed\n",
  yyFunction);
 DerivedTypes_Exit ();
}

rbool IsExplicitlyMappedType ARGS ((tTree t));
rbool IsExplicitlyMappedTypeObj ARGS ((tDefinitions t));
static rbool HasMappedEntry ARGS ((tDefinitions comps));
static rbool IsMappedEntry ARGS ((tDefinitions v));

rbool IsExplicitlyMappedType
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
  if (t->Kind == kTYPE_ID) {
/* line 45 "DerivedTypes.puma" */
  {
/* line 47 "DerivedTypes.puma" */
   if (! ((IsExplicitlyMappedTypeObj (t->TYPE_ID.ID->TYPE_OBJ.Object)))) goto yyL1;
  }
   return rtrue;
yyL1:;

  }
  return rfalse;
}

rbool IsExplicitlyMappedTypeObj
# if defined __STDC__ | defined __cplusplus
(register tDefinitions t)
# else
(t)
 register tDefinitions t;
# endif
{
/* line 52 "DerivedTypes.puma" */
  {
/* line 54 "DerivedTypes.puma" */
   if (! ((HasMappedEntry (t->TypeObject.Components)))) goto yyL1;
  }
   return rtrue;
yyL1:;

  return rfalse;
}

static rbool HasMappedEntry
# if defined __STDC__ | defined __cplusplus
(register tDefinitions comps)
# else
(comps)
 register tDefinitions comps;
# endif
{
  if (comps->Kind == kENTRY_LIST) {
/* line 64 "DerivedTypes.puma" */
  {
/* line 66 "DerivedTypes.puma" */
   if (! ((IsMappedEntry (comps->ENTRY_LIST.Elem)))) goto yyL1;
  }
   return rtrue;
yyL1:;

/* line 69 "DerivedTypes.puma" */
  {
/* line 71 "DerivedTypes.puma" */
   if (! ((HasMappedEntry (comps->ENTRY_LIST.Next)))) goto yyL2;
  }
   return rtrue;
yyL2:;

  }
  return rfalse;
}

static rbool IsMappedEntry
# if defined __STDC__ | defined __cplusplus
(register tDefinitions v)
# else
(v)
 register tDefinitions v;
# endif
{
  if (v->Kind == kVarObject) {
  if (v->VarObject.Dist->Mapping.spec->Kind == kMapDist) {
/* line 76 "DerivedTypes.puma" */
   return rtrue;

  }
  if (v->VarObject.Dist->Mapping.spec->Kind == kMapAlign) {
/* line 79 "DerivedTypes.puma" */
   return rtrue;

  }
  if (v->VarObject.decl->Kind == kVAR_DECL) {
/* line 82 "DerivedTypes.puma" */
  {
/* line 84 "DerivedTypes.puma" */
   if (! ((IsExplicitlyMappedType (GetBaseType (v->VarObject.decl->VAR_DECL.VAL))))) goto yyL3;
  }
   return rtrue;
yyL3:;

  }
  }
  return rfalse;
}

void BeginDerivedTypes ARGS ((void))
{
}

void CloseDerivedTypes ARGS ((void))
{
}
