# ifndef yyCallGraph
# define yyCallGraph

extern char CallGraph_module_does_not_match_evaluator_module_158242;
extern char generate_CallGraph_module_without_option_0;

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# define const
# endif

# include <stdio.h>

# ifndef rbool
# define rbool char
# endif
# define NoCallGraph (tCallGraph) 0L
# define kCallingGraph 1
# define kCallNode 2
# define kCallNodeList 3
# define kCallEdgeList 4
# define yyBlockSize 20480

typedef unsigned char CallGraph_tKind;
typedef unsigned short CallGraph_tMark;
typedef unsigned short CallGraph_tLabel;
typedef union CallGraph_Node * tCallGraph;
typedef tCallGraph tCallingGraph;
typedef tCallGraph tCallNode;
typedef tCallGraph tCallNodeList;
typedef tCallGraph tCallEdgeList;
typedef void (* CallGraph_tProcTree) ARGS ((tCallGraph));
typedef tCallGraph * yytCallGraphPtr;
typedef struct { tCallGraph yyOld, yyNew; } yytCallGraphOldToNew;

typedef struct yysCallGraph_Block {
 char yyBlock [yyBlockSize];
 struct yysCallGraph_Block * yySuccessor;
} yytCallGraph_Block, * yytCallGraph_BlockPtr;

/* line 34 "fortran.call" */


#include "Tree.h"
#include "Definitions.h"



# define CallGraph_InitHead(ptr, kind) ptr->Kind = kind; \
   ptr->yyHead.yyMark = 0; \
   beginNodeHead (ptr)
# ifndef CallGraph_NodeHead
# define CallGraph_NodeHead
# endif
typedef struct { CallGraph_tKind yyKind; CallGraph_tMark yyMark;
 CallGraph_NodeHead } CallGraph_tNodeHead;
typedef struct { CallGraph_tNodeHead yyHead;
tCallGraph UserNodes; tCallGraph IntrinsicNodes; tCallGraph ExternalNodes; } yCallingGraph;
typedef struct { CallGraph_tNodeHead yyHead;
tObject val; int unitkind; tCallGraph calling; tCallGraph called_by; } yCallNode;
typedef struct { CallGraph_tNodeHead yyHead;
tCallGraph Elem; tCallGraph Next; } yCallNodeList;
typedef struct { CallGraph_tNodeHead yyHead;
tCallGraph Node; int count; tCallGraph Next; } yCallEdgeList;

union CallGraph_Node {
 CallGraph_tKind Kind;
 CallGraph_tNodeHead yyHead;
 yCallingGraph CallingGraph;
 yCallNode CallNode;
 yCallNodeList CallNodeList;
 yCallEdgeList CallEdgeList;
};

extern const unsigned short CallGraph_NodeSize [5];
extern const char * const CallGraph_NodeName [];

extern tCallGraph CallGraphRoot;
extern unsigned long CallGraph_HeapUsed;
extern yytCallGraph_BlockPtr CallGraph_BlockList;
extern char * CallGraph_PoolFreePtr, * CallGraph_PoolStartPtr;

extern void (* CallGraph_Exit) ARGS ((void));
extern tCallGraph CallGraph_Alloc ARGS ((unsigned short yySize));
extern tCallGraph MakeCallGraph ARGS ((CallGraph_tKind yyKind));
extern rbool CallGraph_IsType ARGS ((register tCallGraph yyt,
 register CallGraph_tKind yyKind));

extern tCallGraph mCallingGraph
 ARGS ((tCallGraph pUserNodes, tCallGraph pIntrinsicNodes, tCallGraph pExternalNodes));
extern tCallGraph mCallNode
 ARGS ((tObject pval, int punitkind, tCallGraph pcalling, tCallGraph pcalled_by));
extern tCallGraph mCallNodeList
 ARGS ((tCallGraph pElem, tCallGraph pNext));
extern tCallGraph mCallEdgeList
 ARGS ((tCallGraph pNode, int pcount, tCallGraph pNext));

extern void ReleaseCallGraph ARGS ((tCallGraph yyt));
extern void ReleaseCallGraphModule ARGS ((void));
extern void WriteCallGraphNode ARGS ((FILE * yyyf, tCallGraph yyt));
extern void WriteCallGraph ARGS ((FILE * yyyf, tCallGraph yyt));
extern tCallGraph ReadCallGraph ARGS ((FILE * yyyf));
extern void PutCallGraph ARGS ((FILE * yyyf, tCallGraph yyt));
extern tCallGraph GetCallGraph ARGS ((FILE * yyyf));
extern void TraverseCallGraphTD ARGS ((tCallGraph yyt, CallGraph_tProcTree yyyProc));
extern void TraverseCallGraphBU ARGS ((tCallGraph yyt, CallGraph_tProcTree yyProc));
extern tCallGraph ReverseCallGraph ARGS ((tCallGraph yyt));
extern void ForallCallGraph ARGS ((tCallGraph yyt, CallGraph_tProcTree yyProc));
extern tCallGraph CopyCallGraph ARGS ((tCallGraph yyt));
extern rbool CheckCallGraph ARGS ((tCallGraph yyt));
extern void QueryCallGraph ARGS ((tCallGraph yyt));
extern void DrawCallGraph ARGS ((tCallGraph yyt));
extern void SetDepthCallGraph ARGS ((int yyDepth));
extern void SetBoxCallGraph ARGS ((int yyWidth, int yyHeight));
extern rbool IsEqualCallGraph ARGS ((tCallGraph yyt1, tCallGraph yyt2));
extern void InitCallGraph ARGS ((register tCallGraph yyt));
extern void BeginCallGraph ARGS ((void));
extern void CloseCallGraph ARGS ((void));

# endif
