# ifndef yyDefTable
# define yyDefTable

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef rbool
# define rbool char
# endif

# include "Tree.h"
# include "Definitions.h"


extern void (* DefTable_Exit) ARGS ((void));

extern void NewScope ARGS ((void));
extern void OpenScope ARGS ((tDefinitions Scope));
extern void CloseScope ARGS ((void));
extern tDefinitions GetCurrentScope ARGS ((void));
extern tDefinitions GetExternalEntries ARGS ((void));
extern tDefinitions GetIntrinsicEntries ARGS ((void));
extern tDefinitions GetUnitEntries ARGS ((void));
extern tDefinitions GetCommonEntries ARGS ((void));
extern void InsertUnitEntry ARGS ((tDefinitions Obj));
extern void InsertExternalEntry ARGS ((tDefinitions Obj));
extern void InsertCommonEntry ARGS ((tDefinitions Obj));
extern void InsertEntry ARGS ((tDefinitions Obj));
extern void ChangeEntry ARGS ((tIdent Name, tDefinitions Obj));
extern tDefinitions GetDeclEntry ARGS ((tIdent Ident, tDefinitions Decls));
extern tDefinitions GetLocalObject ARGS ((tIdent Ident));
extern tDefinitions GetGlobalObject ARGS ((tIdent Ident));
extern tDefinitions GetIntrinsicObject ARGS ((tIdent Ident));
extern tDefinitions GetHPFLibrary ARGS ((void));
extern tDefinitions GetHPFLocalLibrary ARGS ((void));
extern tDefinitions GetHPFTaskLibrary ARGS ((void));
extern tDefinitions GetDefaultTopology ARGS ((int rank));
extern tDefinitions RemoveHostAssociation ARGS ((void));
extern void ResetHostAssociation ARGS ((tDefinitions HostAssociation));

extern void BeginDefTable ARGS ((void));
extern void CloseDefTable ARGS ((void));

# endif
