# ifndef yyDefinitions
# define yyDefinitions

extern char Definitions_module_does_not_match_evaluator_module_15257138;
extern char generate_Definitions_module_without_option_0;

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# define const
# endif

# include <stdio.h>

# ifndef rbool
# define rbool char
# endif
# define NoDefinitions (tDefinitions) 0L
# define kScopes 1
# define kSCOPE_LIST 2
# define kSCOPE_EMPTY 3
# define kEntries 4
# define kENTRY_LIST 5
# define kENTRY_EMPTY 6
# define kObject 7
# define kVarObject 8
# define kTemplateObject 9
# define kRaggedObject 10
# define kTopologyObject 11
# define kTypeObject 12
# define kExternalObject 13
# define kProcObject 14
# define kFuncObject 15
# define kBlockObject 16
# define kModuleObject 17
# define kGenericObject 18
# define kCommonObject 19
# define kNameListObject 20
# define kVarUse 21
# define kMapping 22
# define kSpecMapping 23
# define kMapDefault 24
# define kMapReplicated 25
# define kMapDecl 26
# define kMapDist 27
# define kMapAlign 28
# define kMapInherited 29
# define kDistribution 30
# define kAlignment 31
# define kRangeMapping 32
# define kRangeDefault 33
# define kRangeNone 34
# define kRangeDecl 35
# define kRangeSelection 36
# define kRangeMapList 37
# define kRangeList 38
# define kRangeEmpty 39
# define kRangeSelector 40
# define kRangeReplicated 41
# define kRangeDist 42
# define kRangeAlign 43
# define kVarDescription 44
# define kVarDummy 45
# define kVarParameter 46
# define kVarLocal 47
# define kVarCommon 48
# define kDimList 49
# define kDIM_LIST 50
# define kDIM_EMPTY 51
# define kDimDescription 52
# define kSerialDimension 53
# define kDistributedDimension 54
# define kAlignedDimension 55
# define kMappedDimension 56
# define kReplicatedDimension 57
# define kEmbeddedDimension 58
# define yyBlockSize 20480

typedef unsigned char Definitions_tKind;
typedef unsigned short Definitions_tMark;
typedef unsigned short Definitions_tLabel;
typedef union Definitions_Node * tDefinitions;
typedef tDefinitions tScopes;
typedef tDefinitions tEntries;
typedef tDefinitions tObject;
typedef tDefinitions tVarUse;
typedef tDefinitions tMapping;
typedef tDefinitions tSpecMapping;
typedef tDefinitions tDistribution;
typedef tDefinitions tAlignment;
typedef tDefinitions tRangeMapping;
typedef tDefinitions tRangeMapList;
typedef tDefinitions tRangeSelector;
typedef tDefinitions tVarDescription;
typedef tDefinitions tDimList;
typedef tDefinitions tDimDescription;
typedef void (* Definitions_tProcTree) ARGS ((tDefinitions));
typedef tDefinitions * yytDefinitionsPtr;
typedef struct { tDefinitions yyOld, yyNew; } yytDefinitionsOldToNew;

typedef struct yysDefinitions_Block {
 char yyBlock [yyBlockSize];
 struct yysDefinitions_Block * yySuccessor;
} yytDefinitions_Block, * yytDefinitions_BlockPtr;

/* line 22 "definitions.cg" */


    /***********************************
    *  Some Constants used             *
    ************************************/

    /***********************************
    *   VarDummy (intent, _, _)        *
    ************************************/

#define IntentNo     0
#define IntentIn     1
#define IntentOut    2
#define IntentInOut  3

    /***********************************
    *  VarObject (arr_kind := xxx)     *
    ***********************************/

# define arr_default         0    /*  not fixed so far            */
# define arr_allocatable     1    /*  ALLOCATABLE attribute       */
# define arr_pointer         2    /*  POINTER     attribute       */
# define arr_fixed_size      3    /*  size known at compile time  */
# define arr_automatic       4    /*  explicit shape, unknown     */
# define arr_explicit_shape  5    /*  explicit shape for dummies  */
# define arr_assumed_shape   6    /*  assumed shape for dummies   */
# define arr_assumed_size    7    /*  assumed size  for dummies   */

   /* values for the private attribute of objects */

    /***********************************
    *   Object (_, _, _, pkind)        *
    ***********************************/

# define Default 0
# define Public  1
# define Private 2

    /***********************************
    *   VarLocal (save, _, _)          *
    ***********************************/

# define IsSave    1

    /***********************************
    *   VarLocal (_, _, atts)          *
    ***********************************/

# define AttrTarget       1

    /***********************************
    *   CommonObject (..., sequence)   *
    ***********************************/

# define IsSequence   1
# define IsNoSequence 2 

   /* values for the kind of ProcObject, FuncObject */

    /*****************************************
    *   FuncObject     (_, _, _, _, kind, _) *
    *   ProcObject     (_, _, _, _, kind, _) *
    *   ExternalObject (_, _, _, _, kind, _) *
    *****************************************/

# define UserRoutine   0
# define DummyRoutine  1
# define ModuleRoutine 2

# define NoObject       NoDefinitions
# define NoEntries      NoDefinitions
# define NoDistribution NoDefinitions

# define tDistribution  tDefinitions  /* type for distributions            */
# define tObject        tDefinitions  /* type for object descriptors       */
# define tEntries       tDefinitions  /* type to represent sets of decls.  */
# define tScopes        tDefinitions  /* type to represent scopes          */

# include "Idents.h"
# include "Tree.h"
# include "global.h"     /* MAX_DIMENSIONS */

    /*****************************************
    *                                        *
    *  Arrays for distributed dimensions     *
    *                                        *
    *****************************************/

typedef struct {
     int no_dims;
     int DimsArray [MAX_DIMENSIONS];
     } DistributedDimensions;



# define Definitions_InitHead(ptr, kind) ptr->Kind = kind; \
   ptr->yyHead.yyMark = 0; \
   beginNodeHead (ptr)
# ifndef Definitions_NodeHead
# define Definitions_NodeHead
# endif
typedef struct { Definitions_tKind yyKind; Definitions_tMark yyMark;
 Definitions_NodeHead } Definitions_tNodeHead;
typedef struct { Definitions_tNodeHead yyHead;
} yScopes;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Table; tDefinitions Hidden; } ySCOPE_LIST;
typedef struct { Definitions_tNodeHead yyHead;
} ySCOPE_EMPTY;
typedef struct { Definitions_tNodeHead yyHead;
} yEntries;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Elem; tDefinitions Next; } yENTRY_LIST;
typedef struct { Definitions_tNodeHead yyHead;
} yENTRY_EMPTY;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; } yObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; tDefinitions Kind; int arr_kind; rbool target; rbool trace; rbool tree; int dsp_kind; int sequence; tTree select; tTree shadow; tDefinitions uses; tDefinitions Dist; } yVarObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; tTree select; tDefinitions Dist; } yTemplateObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int depth; tDefinitions Levels; tDefinitions Dist; } yRaggedObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int rank; tTree target; int active; int defined; } yTopologyObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; tDefinitions Components; } yTypeObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int Kind; tDefinitions Declarations; } yExternalObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int Kind; tDefinitions Declarations; } yProcObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int Kind; tDefinitions Declarations; } yFuncObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int uses; tDefinitions Declarations; } yBlockObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; int uses; tDefinitions Declarations; } yModuleObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; tDefinitions Interfaces; } yGenericObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; tDefinitions CommonElements; int size; int main; int distributed_vars; int sequence; } yCommonObject;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Ident; tTree decl; int private; tObject in; } yNameListObject;
typedef struct { Definitions_tNodeHead yyHead;
int ArrayUse; int ReadUse; int WriteUse; } yVarUse;
typedef struct { Definitions_tNodeHead yyHead;
int dynamic; int shared; tDefinitions spec; tDefinitions range; } yMapping;
typedef struct { Definitions_tNodeHead yyHead;
} ySpecMapping;
typedef struct { Definitions_tNodeHead yyHead;
} yMapDefault;
typedef struct { Definitions_tNodeHead yyHead;
} yMapReplicated;
typedef struct { Definitions_tNodeHead yyHead;
tTree decl; } yMapDecl;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Distribution; } yMapDist;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Alignment; } yMapAlign;
typedef struct { Definitions_tNodeHead yyHead;
} yMapInherited;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions top_obj; tDefinitions ArrayList; } yDistribution;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions template_obj; tDefinitions TargetList; tDefinitions SourceList; } yAlignment;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeMapping;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeDefault;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeNone;
typedef struct { Definitions_tNodeHead yyHead;
tTree decl; } yRangeDecl;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Selections; } yRangeSelection;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeMapList;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Elem; tDefinitions Next; } yRangeList;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeEmpty;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeSelector;
typedef struct { Definitions_tNodeHead yyHead;
} yRangeReplicated;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions ArrayList; } yRangeDist;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Alignment; } yRangeAlign;
typedef struct { Definitions_tNodeHead yyHead;
} yVarDescription;
typedef struct { Definitions_tNodeHead yyHead;
int Intent; tTree function; rbool optional; int layout; int pass_by; int map_to; } yVarDummy;
typedef struct { Definitions_tNodeHead yyHead;
tTree Val; } yVarParameter;
typedef struct { Definitions_tNodeHead yyHead;
int save; } yVarLocal;
typedef struct { Definitions_tNodeHead yyHead;
tIdent Block; tDefinitions ref_obj; } yVarCommon;
typedef struct { Definitions_tNodeHead yyHead;
} yDimList;
typedef struct { Definitions_tNodeHead yyHead;
tDefinitions Elem; tDefinitions Next; } yDIM_LIST;
typedef struct { Definitions_tNodeHead yyHead;
} yDIM_EMPTY;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; } yDimDescription;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; } ySerialDimension;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; int topology_dim; int kind; tTree size; tTree len; tTree map; } yDistributedDimension;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; int template_dim; tTree mult; tTree add; } yAlignedDimension;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; int template_dim; } yMappedDimension;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; } yReplicatedDimension;
typedef struct { Definitions_tNodeHead yyHead;
int dimension; tTree val; } yEmbeddedDimension;

union Definitions_Node {
 Definitions_tKind Kind;
 Definitions_tNodeHead yyHead;
 yScopes Scopes;
 ySCOPE_LIST SCOPE_LIST;
 ySCOPE_EMPTY SCOPE_EMPTY;
 yEntries Entries;
 yENTRY_LIST ENTRY_LIST;
 yENTRY_EMPTY ENTRY_EMPTY;
 yObject Object;
 yVarObject VarObject;
 yTemplateObject TemplateObject;
 yRaggedObject RaggedObject;
 yTopologyObject TopologyObject;
 yTypeObject TypeObject;
 yExternalObject ExternalObject;
 yProcObject ProcObject;
 yFuncObject FuncObject;
 yBlockObject BlockObject;
 yModuleObject ModuleObject;
 yGenericObject GenericObject;
 yCommonObject CommonObject;
 yNameListObject NameListObject;
 yVarUse VarUse;
 yMapping Mapping;
 ySpecMapping SpecMapping;
 yMapDefault MapDefault;
 yMapReplicated MapReplicated;
 yMapDecl MapDecl;
 yMapDist MapDist;
 yMapAlign MapAlign;
 yMapInherited MapInherited;
 yDistribution Distribution;
 yAlignment Alignment;
 yRangeMapping RangeMapping;
 yRangeDefault RangeDefault;
 yRangeNone RangeNone;
 yRangeDecl RangeDecl;
 yRangeSelection RangeSelection;
 yRangeMapList RangeMapList;
 yRangeList RangeList;
 yRangeEmpty RangeEmpty;
 yRangeSelector RangeSelector;
 yRangeReplicated RangeReplicated;
 yRangeDist RangeDist;
 yRangeAlign RangeAlign;
 yVarDescription VarDescription;
 yVarDummy VarDummy;
 yVarParameter VarParameter;
 yVarLocal VarLocal;
 yVarCommon VarCommon;
 yDimList DimList;
 yDIM_LIST DIM_LIST;
 yDIM_EMPTY DIM_EMPTY;
 yDimDescription DimDescription;
 ySerialDimension SerialDimension;
 yDistributedDimension DistributedDimension;
 yAlignedDimension AlignedDimension;
 yMappedDimension MappedDimension;
 yReplicatedDimension ReplicatedDimension;
 yEmbeddedDimension EmbeddedDimension;
};

extern const unsigned short Definitions_NodeSize [59];
extern const char * const Definitions_NodeName [];

extern tDefinitions DefinitionsRoot;
extern unsigned long Definitions_HeapUsed;
extern yytDefinitions_BlockPtr Definitions_BlockList;
extern char * Definitions_PoolFreePtr, * Definitions_PoolStartPtr;

extern void (* Definitions_Exit) ARGS ((void));
extern tDefinitions Definitions_Alloc ARGS ((unsigned short yySize));
extern tDefinitions MakeDefinitions ARGS ((Definitions_tKind yyKind));
extern rbool Definitions_IsType ARGS ((register tDefinitions yyt,
 register Definitions_tKind yyKind));

extern tDefinitions mScopes
 ARGS ((void));
extern tDefinitions mSCOPE_LIST
 ARGS ((tDefinitions pTable, tDefinitions pHidden));
extern tDefinitions mSCOPE_EMPTY
 ARGS ((void));
extern tDefinitions mEntries
 ARGS ((void));
extern tDefinitions mENTRY_LIST
 ARGS ((tDefinitions pElem, tDefinitions pNext));
extern tDefinitions mENTRY_EMPTY
 ARGS ((void));
extern tDefinitions mObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin));
extern tDefinitions mVarObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, tDefinitions pKind, int parr_kind, rbool ptarget, rbool ptrace, rbool ptree, int pdsp_kind, int psequence, tTree pselect, tTree pshadow, tDefinitions puses, tDefinitions pDist));
extern tDefinitions mTemplateObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, tTree pselect, tDefinitions pDist));
extern tDefinitions mRaggedObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int pdepth, tDefinitions pLevels, tDefinitions pDist));
extern tDefinitions mTopologyObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int prank, tTree ptarget, int pactive, int pdefined));
extern tDefinitions mTypeObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, tDefinitions pComponents));
extern tDefinitions mExternalObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int pKind, tDefinitions pDeclarations));
extern tDefinitions mProcObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int pKind, tDefinitions pDeclarations));
extern tDefinitions mFuncObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int pKind, tDefinitions pDeclarations));
extern tDefinitions mBlockObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int puses, tDefinitions pDeclarations));
extern tDefinitions mModuleObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, int puses, tDefinitions pDeclarations));
extern tDefinitions mGenericObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, tDefinitions pInterfaces));
extern tDefinitions mCommonObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin, tDefinitions pCommonElements, int psize, int pmain, int pdistributed_vars, int psequence));
extern tDefinitions mNameListObject
 ARGS ((tIdent pIdent, tTree pdecl, int pprivate, tObject pin));
extern tDefinitions mVarUse
 ARGS ((int pArrayUse, int pReadUse, int pWriteUse));
extern tDefinitions mMapping
 ARGS ((int pdynamic, int pshared, tDefinitions pspec, tDefinitions prange));
extern tDefinitions mSpecMapping
 ARGS ((void));
extern tDefinitions mMapDefault
 ARGS ((void));
extern tDefinitions mMapReplicated
 ARGS ((void));
extern tDefinitions mMapDecl
 ARGS ((tTree pdecl));
extern tDefinitions mMapDist
 ARGS ((tDefinitions pDistribution));
extern tDefinitions mMapAlign
 ARGS ((tDefinitions pAlignment));
extern tDefinitions mMapInherited
 ARGS ((void));
extern tDefinitions mDistribution
 ARGS ((tDefinitions ptop_obj, tDefinitions pArrayList));
extern tDefinitions mAlignment
 ARGS ((tDefinitions ptemplate_obj, tDefinitions pTargetList, tDefinitions pSourceList));
extern tDefinitions mRangeMapping
 ARGS ((void));
extern tDefinitions mRangeDefault
 ARGS ((void));
extern tDefinitions mRangeNone
 ARGS ((void));
extern tDefinitions mRangeDecl
 ARGS ((tTree pdecl));
extern tDefinitions mRangeSelection
 ARGS ((tDefinitions pSelections));
extern tDefinitions mRangeMapList
 ARGS ((void));
extern tDefinitions mRangeList
 ARGS ((tDefinitions pElem, tDefinitions pNext));
extern tDefinitions mRangeEmpty
 ARGS ((void));
extern tDefinitions mRangeSelector
 ARGS ((void));
extern tDefinitions mRangeReplicated
 ARGS ((void));
extern tDefinitions mRangeDist
 ARGS ((tDefinitions pArrayList));
extern tDefinitions mRangeAlign
 ARGS ((tDefinitions pAlignment));
extern tDefinitions mVarDescription
 ARGS ((void));
extern tDefinitions mVarDummy
 ARGS ((int pIntent, tTree pfunction, rbool poptional, int playout, int ppass_by, int pmap_to));
extern tDefinitions mVarParameter
 ARGS ((tTree pVal));
extern tDefinitions mVarLocal
 ARGS ((int psave));
extern tDefinitions mVarCommon
 ARGS ((tIdent pBlock, tDefinitions pref_obj));
extern tDefinitions mDimList
 ARGS ((void));
extern tDefinitions mDIM_LIST
 ARGS ((tDefinitions pElem, tDefinitions pNext));
extern tDefinitions mDIM_EMPTY
 ARGS ((void));
extern tDefinitions mDimDescription
 ARGS ((int pdimension));
extern tDefinitions mSerialDimension
 ARGS ((int pdimension));
extern tDefinitions mDistributedDimension
 ARGS ((int pdimension, int ptopology_dim, int pkind, tTree psize, tTree plen, tTree pmap));
extern tDefinitions mAlignedDimension
 ARGS ((int pdimension, int ptemplate_dim, tTree pmult, tTree padd));
extern tDefinitions mMappedDimension
 ARGS ((int pdimension, int ptemplate_dim));
extern tDefinitions mReplicatedDimension
 ARGS ((int pdimension));
extern tDefinitions mEmbeddedDimension
 ARGS ((int pdimension, tTree pval));

extern void ReleaseDefinitions ARGS ((tDefinitions yyt));
extern void ReleaseDefinitionsModule ARGS ((void));
extern void WriteDefinitionsNode ARGS ((FILE * yyyf, tDefinitions yyt));
extern void WriteDefinitions ARGS ((FILE * yyyf, tDefinitions yyt));
extern tDefinitions ReadDefinitions ARGS ((FILE * yyyf));
extern void PutDefinitions ARGS ((FILE * yyyf, tDefinitions yyt));
extern tDefinitions GetDefinitions ARGS ((FILE * yyyf));
extern void TraverseDefinitionsTD ARGS ((tDefinitions yyt, Definitions_tProcTree yyyProc));
extern void TraverseDefinitionsBU ARGS ((tDefinitions yyt, Definitions_tProcTree yyProc));
extern tDefinitions ReverseDefinitions ARGS ((tDefinitions yyt));
extern void ForallDefinitions ARGS ((tDefinitions yyt, Definitions_tProcTree yyProc));
extern tDefinitions CopyDefinitions ARGS ((tDefinitions yyt));
extern rbool CheckDefinitions ARGS ((tDefinitions yyt));
extern void QueryDefinitions ARGS ((tDefinitions yyt));
extern void DrawDefinitions ARGS ((tDefinitions yyt));
extern void SetDepthDefinitions ARGS ((int yyDepth));
extern void SetBoxDefinitions ARGS ((int yyWidth, int yyHeight));
extern rbool IsEqualDefinitions ARGS ((tDefinitions yyt1, tDefinitions yyt2));
extern void InitDefinitions ARGS ((register tDefinitions yyt));
extern void BeginDefinitions ARGS ((void));
extern void CloseDefinitions ARGS ((void));

# endif
