/*************************************************************************
*                                                                        *
*  Name : protocol.h                                                     *
*                                                                        *
*  Purpose : Reporting on errors and warnings for translation            *
*                                                                        *
*  Author : Dr. Thomas Brandes, GMD, SCAI.LAB                            *
*                                                                        *
*  Date   : Jul 1992                                                     *
*                                                                        *
*************************************************************************/

# include "Tree.h"
# include "Definitions.h"

       /*************************************************
       *                                                *
       *  some constants to print hints for the user    *
       *                                                *
       *************************************************/
 
# define HINT_HOME   1

extern void open_protocol ARGS((char name[]));

extern void close_protocol ARGS(());

extern int protocol_errors ARGS(());

extern void set_protocol_unit ARGS((tTree t));

extern void set_protocol_stmt ARGS((tTree t));

extern int get_protocol_line ARGS(());

extern void print_protocol ARGS((char s[]));

extern void hint_protocol ARGS((int nr));

extern void tree_protocol ARGS((char s[], tTree t));

extern void obj_protocol ARGS((char s[], tObject o));

extern void simple_error_protocol ARGS((char s[]));

extern void simple_warning_protocol ARGS((char s[]));

extern void tree_error_protocol ARGS((char s[], tTree t));

extern void obj_error_protocol ARGS((char s[], tObject o));

extern void tree_warning_protocol ARGS((char s[], tTree t));

extern void error_protocol ARGS((char message[]));

extern void warning_protocol ARGS((char message[]));

extern void serious_warning_protocol ARGS((char message[]));

extern void stmt_protocol ARGS((char message[]));

extern void info_protocol ARGS((char message[]));

extern void kill_in_protocol ARGS(());

extern void failure_protocol ARGS((char module[], char proc[], tTree t));

extern void failure2_protocol ARGS((char module[], char proc[], 
                                    tTree t1, tTree t2));
